/* Copyright (c) 2005. Chris Richardson. All rights reserved */

package net.chrisrichardson.bankingExample.domain;

public class Account {

    // For Hibernate
    private int id;
    
    private double balance;

    private OverdraftPolicy overdraftPolicy;

    private String accountId;

    // For Hibernate
    protected Account() {
        // for mocking
    }

    public Account(String accountId, double initialBalance) {
        this.accountId = accountId;
        this.balance = initialBalance;
        this.overdraftPolicy = new NoOverdraftAllowed();
    }

    public void debit(double amount)
            throws MoneyTransferException {
        double originalBalance = balance;
        double newBalance = balance - amount;
        overdraftPolicy.beforeDebitCheck(this,
                originalBalance, newBalance);
        balance = newBalance;
        overdraftPolicy.afterDebitCheck(this,
                originalBalance, newBalance);
    }

    public void credit(double amount) {
        balance += amount;
    }

    public double getBalance() {
        return balance;
    }

    public String getAccountId() {
        return accountId;
    }
}
