/* Copyright (c) 2005. Chris Richardson. All rights reserved */

package net.chrisrichardson.bankingExample.domain;

public class MoneyTransferServiceImpl implements
        MoneyTransferService {

    private final AccountRepository accountRepository;

    private final BankingTransactionRepository bankingTransactionRepository;

    public MoneyTransferServiceImpl(
            AccountRepository accountRepository,
            BankingTransactionRepository bankingTransactionRepository) {
        this.accountRepository = accountRepository;
        this.bankingTransactionRepository = bankingTransactionRepository;
    }

    public BankingTransaction transfer(
            String fromAccountId, String toAccountId,
            double amount) throws MoneyTransferException {
        Account fromAccount = accountRepository
                .findAccount(fromAccountId);
        Account toAccount = accountRepository
                .findAccount(toAccountId);
        fromAccount.debit(amount);
        toAccount.credit(amount);
        return bankingTransactionRepository
                .createTransferTransaction(
                        fromAccount, toAccount, amount);
    }

}
