/* Copyright (c) 2005. Chris Richardson. All rights reserved */

package net.chrisrichardson.bankingExample.domain.hibernate;

import java.sql.*;

import org.hibernate.*;
import org.springframework.orm.hibernate3.*;

import net.chrisrichardson.bankingExample.domain.*;

public class HibernateAccountRepository implements AccountRepository {

    private HibernateTemplate hibernateTemplate;

    public HibernateAccountRepository(HibernateTemplate template) {
        hibernateTemplate = template;
    }

    public Account findAccount(final String accountId) {
        return (Account) hibernateTemplate.execute(new HibernateCallback() {

            public Object doInHibernate(Session session)
                    throws HibernateException, SQLException {
                Query query = session
                        .getNamedQuery("Account.findAccountByAccountId");
                query.setParameter("accountId", accountId);
                return query.uniqueResult();
            }
        });
    }

    public Account createAccount(String accountId, double initialBalance) {
        Account account = new Account(accountId, initialBalance);
        hibernateTemplate.save(account);
        return account;
    }

}
