/* Copyright (c) 2005. Chris Richardson. All rights reserved */

package net.chrisrichardson.bankingExample.domain.hibernate;

import net.chrisrichardson.bankingExample.domain.*;
import net.chrisrichardson.ormunit.hibernate.*;

public class HibernateAccountRepositoryTests extends HibernatePersistenceTests {

    private HibernateAccountRepository repository;

    protected String getConfigurationFile() {
        return "configurations/banking-hibernate-domain-model.xml";
    }

    @Override
    protected void setUp() throws Exception {
        super.setUp();
        repository = new HibernateAccountRepository(getHibernateTemplate());
    }
    
    public void test() throws Exception {
        String accountId = "A." + System.currentTimeMillis();
        Account account = repository.createAccount(accountId, 1.0);
        assertNotNull(account);
        Account account2 = repository.findAccount(accountId);
        assertNotNull(account2);
    }
    
    

}
