/* Copyright (c) 2005. Chris Richardson. All rights reserved */

package net.chrisrichardson.bankingExample.domain.hibernate;

import java.util.*;

import org.springframework.orm.hibernate3.*;

import net.chrisrichardson.bankingExample.domain.*;

public class HibernateBankingTransactionRepository implements
        BankingTransactionRepository {

    private HibernateTemplate hibernateTemplate;

    public HibernateBankingTransactionRepository(
            HibernateTemplate hibernateTemplate) {
        this.hibernateTemplate = hibernateTemplate;
    }

    public BankingTransaction createTransferTransaction(Account fromAccount,
            Account toAccount, double amount) {
        TransferTransaction txn = new TransferTransaction(fromAccount,
                toAccount, amount, new Date());
        hibernateTemplate.save(txn);
        return txn;
    }

}
