/* Copyright (c) 2005. Chris Richardson. All rights reserved */

package net.chrisrichardson.bankingExample.facade;

import net.chrisrichardson.bankingExample.domain.*;

public class AccountManagementFacadeImpl implements AccountManagementFacade {

    private MoneyTransferService transferService;
    private AccountRepository accountRepository;
    
    public AccountManagementFacadeImpl(AccountRepository repository, MoneyTransferService service) {
        this.accountRepository = repository;
        this.transferService = service;
    }

    public Account createAccount(String accountId, double initialBalance) {
        return accountRepository.createAccount(accountId, initialBalance);
    }

    public double getBalance(String accountId) {
        Account account = accountRepository.findAccount(accountId);
        return account.getBalance();
    }

    public BankingTransaction transfer(String fromAccountId,
            String toAccountId, double amount) throws MoneyTransferException {
        return transferService.transfer(fromAccountId, toAccountId, amount);
    }


}
