/* Copyright (c) 2005. Chris Richardson. All rights reserved */

package net.chrisrichardson.bankingExample.facade;

import net.chrisrichardson.bankingExample.domain.*;

import org.jmock.Mock;
import org.jmock.cglib.MockObjectTestCase;

public class AccountManagementFacadeImplTests extends MockObjectTestCase {

    private Mock mockAccountRepository;

    private Mock mockMoneyTranferService;

    private AccountManagementFacadeImpl facade;

    @Override
    protected void setUp() throws Exception {
        super.setUp();

        mockAccountRepository = new Mock(AccountRepository.class);
        mockMoneyTranferService = new Mock(MoneyTransferService.class);
        AccountRepository accountRepository = (AccountRepository) mockAccountRepository
                .proxy();
        MoneyTransferService moneyTranferService = (MoneyTransferService) mockMoneyTranferService
                .proxy();
        facade = new AccountManagementFacadeImpl(accountRepository,
                moneyTranferService);
    }

    public void testTransfer() throws Exception {

        String accountId1 = "A." + System.currentTimeMillis();
        double initialBalance1 = 10;
        String accountId2 = "B." + System.currentTimeMillis();
        double initialBalance2 = 20;

        mockMoneyTranferService.expects(once()).method("transfer").with(
                eq(accountId1), eq(accountId2), eq(5.0));

        BankingTransaction transaction = facade.transfer(accountId1,
                accountId2, 5);

    }
}
