/* Copyright (c) 2005. Chris Richardson. All rights reserved */

package net.chrisrichardson.foodToGo.util.spring;

import java.sql.*;

import org.springframework.dao.*;
import org.springframework.jdbc.support.*;

public class MyOracleSQLExceptionTranslator extends
        SQLErrorCodeSQLExceptionTranslator {

    protected DataAccessException customTranslate(String task,
            String sql, SQLException sqlex) {
        switch (sqlex.getErrorCode()) {
        case 8177:
            return new CannotSerializeTransactionException(
                    "Can't serialize", sqlex);
        case 60:
            return new CannotAcquireLockException(
                    "Deadlock", sqlex);
        default:
            return null;
        }
    }
}