/* Copyright (c) 2005. Chris Richardson. All rights reserved */

package net.chrisrichardson.foodToGo.util.spring;

import org.springframework.beans.factory.*;
import org.springframework.beans.factory.access.*;
import org.springframework.context.access.*;

public class TheBeanFactory {

    public static Object getBean(String name, Class type) {
        return getBean(null, null, name, type);
    }

    public static Object getBean(String selector,
            String factoryKey, String name, Class type) {
        if (selector == null)
            selector = "configurations/default-spring-context.xml";
        if (factoryKey == null)
            factoryKey = "spring-context.xml";
        BeanFactoryReference reference = ContextSingletonBeanFactoryLocator
                .getInstance(
                        System.getProperty("spring.configuration",
                                selector)).useBeanFactory(
                        factoryKey);
        BeanFactory beanFactory = reference.getFactory();
        return beanFactory.getBean(name, type);
    }

}