/* Copyright (c) 2005. Chris Richardson. All rights reserved */

package net.chrisrichardson.ormunit.hibernate;

import java.util.*;
import java.util.Set;

import org.hibernate.mapping.*;
import org.hibernate.mapping.Collection;


public class ComponentCollectionFieldMapping {

    protected final Property property;
    private final Collection value;
    private ComponentFieldMapping componentMapping;

    public ComponentCollectionFieldMapping(Property property, Collection value) {
        this.property = property;
        this.value = value;
        this.componentMapping = new ComponentFieldMapping(property, (Component)value.getElement());        
    }

    public void assertField(String fieldName, String columnName) {
        componentMapping.assertField(fieldName, columnName);
    }

    public void assertManyToOneField(String fieldName, String foreignKeyColumnName) {
        componentMapping.assertManyToOneField(fieldName,
                foreignKeyColumnName);
    }

    public void assertNonPersistentFields(Set nonPersistentFields) {
        componentMapping
                .assertNonPersistentFields(nonPersistentFields);
    }
    
    public void assertNonPersistentFields(String field) {
        assertNonPersistentFields(Collections.singleton(field));
    }



}
