/* Copyright (c) 2005. Chris Richardson. All rights reserved */

package net.chrisrichardson.ormunit.hibernate;

import junit.framework.*;
import org.hibernate.mapping.*;


public class CompositeListFieldMapping extends ComponentCollectionFieldMapping {

    private final org.hibernate.mapping.List value;

    public CompositeListFieldMapping(Property property, org.hibernate.mapping.List value) {
        super(property, value);
        this.value = value;
    }

    public void assertForeignKey(String foreignKeyColumnName) {
        KeyValue keyValue = value.getKey();
        HibernateAssertUtil.assertColumn(foreignKeyColumnName, keyValue);
    }

    public void assertIndexColumn(String indexColumnName) {
        Value indexValue = value.getIndex();
        HibernateAssertUtil.assertColumn(indexColumnName, indexValue);
    }

    public void assertTable(String tableName) {
        Assert.assertEquals(tableName, value.getElement().getTable().getName());
    }
}
