/* Copyright (c) 2005. Chris Richardson. All rights reserved */

package net.chrisrichardson.ormunit.hibernate;

import net.chrisrichardson.foodToGo.util.spring.*;

import org.hibernate.*;
import org.hibernate.cfg.*;
import org.springframework.orm.hibernate3.*;

import junit.framework.*;

public class HibernateORMTestCase extends TestCase {

    protected SessionFactory getSessionFactory() {
        return (SessionFactory) getBean(
                "mySessionFactory", SessionFactory.class);
    }

    protected Configuration getConfiguration() {
        LocalSessionFactoryBean beanFactory = (LocalSessionFactoryBean) getBean("&mySessionFactory", LocalSessionFactoryBean.class);
        return beanFactory.getConfiguration();
    }

    protected Object getBean(String name, Class beanType) {
        return TheBeanFactory
                .getBean(
                        getConfigurationFile(),
                        null,
                        name,
                        beanType);
    }

    protected String getConfigurationFile() {
        return "configurations/hibernate-domain-model.xml";
    }

}
